from selenium import webdriver
from selenium.webdriver.common.by import By
import time
import os
import sys
from datetime import datetime
from selenium.webdriver.chrome.options import Options
 
#options = Options()
#options.add_argument('--headless')
#driver = webdriver.Chrome(options=options)
driver = webdriver.Chrome()

dt = datetime.now()
if  dt.hour <= 11 :
    pmf=0
else :
    pmf=1

citycode = 1410000 # 横浜市　
#citycode = 1310100 # 千代田区　
#citycode = 1510000 # 新潟市
#citycode = 110000 # 札幌市
#citycode = 121400 # 稚内市
#citycode = 4720700 # 石垣島
args = sys.argv
if 2 == len(args):
    print(args[1])
    citycode = int(args[1])

url = "https://www.jma.go.jp/bosai/#pattern=forecast&area_type=class20s&area_code=%07d" % (citycode) 
driver.get(url) 
driver.implicitly_wait(5)
time.sleep(1)

tables = driver.find_elements(By.CLASS_NAME, "forecast-table")
trlist = tables[2].find_elements(By.TAG_NAME, 'tr')
#------------------------------------------------------------------------------
thlist = trlist[1].find_elements(By.TAG_NAME, 'th')
day_a=[]
for thitem in thlist[1:]:
    day=0
    for c in thitem.text:
        v = ord(c)
        if v >= 0x30 and v <= 0x39:
            day = day*10+v-0x30
        else:    
            if day > 0:
                day_a.append(day)
                break
#------------------------------------------------------------------------------
forc_ta=[]
forc_ia=[]
tdlist = trlist[2].find_elements(By.TAG_NAME, 'td')
for tditem in tdlist:
    forc_ta.append(tditem.text)
    img = tditem.find_element(By.TAG_NAME, 'img')
    imgurl = img.get_attribute("src")
    if imgurl:
        fn=imgurl
        fp= fn.rfind("/")
        ep= fn.rfind(".")
        if fp != -1 and ep != -1 :
            fn = fn[fp+1:ep]
        fne=fn + ".png"
        forc_ia.append(fn)
#        if not os.path.isfile(fne):
        with open(fne, 'wb') as f:
            f.write(img.screenshot_as_png)
#------------------------------------------------------------------------------
tdlist = trlist[3].find_elements(By.TAG_NAME, 'td')
rain_a=[]
for tditem in tdlist :
    rain_a.append(tditem.text)
#------------------------------------------------------------------------------
tdlist = trlist[5].find_elements(By.TAG_NAME, 'td')
tempmin_a=[]
tempmax_a=[]
for tditem in tdlist :
    temp = tditem.find_element(By.CLASS_NAME, "forecast-min-temp")
    tempmin_a.append(temp.text)
    temp = tditem.find_element(By.CLASS_NAME, "forecast-max-temp")
    tempmax_a.append(temp.text)
#------------------------------------------------------------------------------
driver.close()
f = open('%02d_%d_weth.txt' % (dt.day,pmf), encoding='utf-16', mode='w')
for i in range(len(day_a)) :
    f.write('%s,%s,%s,%s,%s,%s,\n' % (day_a[i], forc_ta[i], forc_ia[i], rain_a[i], tempmin_a[i], tempmax_a[i] ))
f.close()

