from selenium import webdriver 
from selenium.webdriver.common.by import By 
from selenium.webdriver.chrome.options import Options
import time
import os
from datetime import datetime
from calendar import isleap
import sys

if len(sys.argv) < 2:
    print("No argument.")        
    exit(0)            

years = sys.argv[1]
yeard = int(years)
print(f"year : {years}")

dt = datetime.now()

print(dt.year)

datetime_str = dt.strftime("%Y-%m-%d %H:%M:%S")
print(datetime_str)
leapf=isleap(yeard)
print(f' {yeard} : leapf : {leapf}')

date = datetime( yeard,1,1) 
day7 = date.weekday()
print('day7 :', day7)

shuku_a = [[] for i in range(12) ]
rokuyo_a = [[] for i in range(12) ]
nanayo_a = [[] for i in range(12) ]
sekki_a = [[] for i in range(12) ]

#----Rokuyo, Day of week, init others-----------------------------------------------------
if dt.year == yeard : 
    url = "https://www.benri.com/calendar/"
else :     
    url = "https://www.benri.com/calendar/%s.html" % (years)
driver = webdriver.Chrome()
driver.get(url) 
#time.sleep(1)
for m in range(1,13) :
    if m == 1 :
        dx=31
    elif m == 2 :
        if leapf == True : 
            dx=29
        else :
            dx=28
    elif m == 3 :
        dx=31
    elif m == 4 :
        dx=30
    elif m == 5 :
        dx=31
    elif m == 6 :
        dx=30
    elif m == 7 :
        dx=31
    elif m == 8 :
        dx=31
    elif m == 9 :
        dx=30
    elif m == 10 :
        dx=31
    elif m == 11 :
        dx=30
    else :
        dx=31
    for d in range(1,dx+1) :
        day_m_d = driver.find_element(By.ID,  'td%d-%d-%d' % (yeard, m, d))
        divs = day_m_d.find_elements(By.TAG_NAME,  'div')
        s = divs[1].text
        if s == '赤口' :
            d6=0
        elif s == '先勝' :
            d6=1
        elif s == '友引' :
            d6=2
        elif s == '先負' :
            d6=3
        elif s == '仏滅' :
            d6=4
        else : 
            d6=5
        rokuyo_a[m-1].append(d6)
        shuku_a[m-1].append('')
        sekki_a[m-1].append('')
        nanayo_a[m-1].append(day7)
        day7+=1
        if day7 == 7 :
            day7 = 0

#------national holiday---------------------------------------------------------
shuku_d = []
shuku_t = []
shuku = driver.find_element(By.ID,  'ShukuList')
divs = shuku.find_elements(By.TAG_NAME,  'div')
for div in divs :
    cls = div.get_attribute("class")
    if cls == 'SH_dt' : 
        shuku_d.append(div.text) 
    elif cls == 'SH_str' :
        shuku_t.append(div.text)

for i in range(len(shuku_d)) :
    s=shuku_d[i]
    fp= s.find("年")
    mp= s.find("月")
    ep= s.find("日")
    md=int(s[fp+1:mp])   
    dd=int(s[mp+1:ep])   
    # print(f'date:{shuku_d[i]} title:{shuku_t[i]} md:{md} dd:{dd}')
    shuku_a[md-1][dd-1]=shuku_t[i]
#--------24 solar term,Miscellaneous -------------------------------------------
sekki = []

url = 'https://eco.mtk.nao.ac.jp/koyomi/yoko/%s/rekiyou%s2.html' % (years, years[2:])
driver.get(url) 
#time.sleep(1)
table = driver.find_element(By.XPATH,  '/html/body/div[7]/table')
trlist = table.find_elements(By.TAG_NAME,  'tr')
for tritem in trlist[1:] : 
    tdlist = tritem.find_elements(By.TAG_NAME, 'td')
    if len(tdlist) == 4 :
        sekki.append([tdlist[0].text, tdlist[2].text])
table = driver.find_element(By.XPATH,  '/html/body/div[8]/table')
trlist = table.find_elements(By.TAG_NAME,  'tr')
for tritem in trlist[1:] : 
    tdlist = tritem.find_elements(By.TAG_NAME, 'td')
    if len(tdlist) == 4 :
        sekki.append([tdlist[0].text, tdlist[2].text])

for sekki_i in sekki :
    s=sekki_i[1]
    mp= s.find("月")
    ep= s.find("日")
    md=int(s[:mp])   
    dd=int(s[mp+1:ep])   
    # print(sekki_i[0], sekki_i[1], md,dd)
    sekki_a[md-1][dd-1]=sekki_i[0] 
#-----sunrise, sunset----------------------------------------------------------
sunrise_a = [[] for i in range(12) ]
sunset_a = [[] for i in range(12) ]

for m in range(12) : 
    url = 'https://eco.mtk.nao.ac.jp/koyomi/dni/%s/s13%02d.html' % (years, m+1)
    driver.get(url) 
    # time.sleep(2)
    table = driver.find_element(By.CLASS_NAME, "result")
    trlist = table.find_elements(By.TAG_NAME,  'tr')
    for tritem in trlist[1:] : 
        tdlist = tritem.find_elements(By.TAG_NAME, 'td')
        sunrise_a[m].append(tdlist[1].text)
        sunset_a[m].append(tdlist[5].text)
#------------------------------------------------------------------------------
driver.quit()
f = open('%s_calen.txt' % (years), encoding='utf-16', mode='w')
for i in range(12) :
    for j in range(len(rokuyo_a[i])) :
        f.write('%s/%d/%d,%d,%d,%s,%s,%s,%s,\n' % (years, i+1, j+1, nanayo_a[i][j], rokuyo_a[i][j], shuku_a[i][j], sekki_a[i][j], sunrise_a[i][j], sunset_a[i][j] ))
f.close()
